#include "alloc.h"
#include "debug.h"
#include "drivers.h"
#include "gdt.h"
#include "idt.h"
#include "kprintf.h"
#include "memory.h"
#include "multiboot.h"
#include "power.h"
#include "shell.h"
#include "string.h"
#include "terminal.h"

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

/* Check if the compiler thinks you are targeting the wrong operating system. */
#if defined(__linux__)
#error                                                                         \
    "You are not using a cross-compiler, you will most certainly run into trouble"
#endif

/* This tutorial will only work for the 32-bit ix86 targets. */
#if !defined(__i386__)
#error "This tutorial needs to be compiled with a ix86-elf compiler"
#endif

/* Par contre je me dois d'être honnête avec toi, j'ai passé un très bon moment
 * hier soir c'était vraiment posé et tout mais j'ai pas trop ressenti de
 * feeling qui me donnerait envie de continuer dans une relation "couple" sur le
 * long terme. Je sais pas trop comment le dire sans que ça te blesse, c'est pas
 * personnel ou quoi c'est cool quand on parle et tout mais juste je ne pense
 * pas pouvoir faire marcher une relation comme celle là :( */
/* Voilà je voulais juste te le dire pour pas que tu te mettes quelque chose en
 * tête qui n'arrivera pas, je trouve ça plus correct */

static void set_mem_size(multiboot_info_t *mbd, uint32_t magic)
{
	/* Make sure the magic number matches for memory mapping */
	if (magic != MULTIBOOT_BOOTLOADER_MAGIC)
		kpanic("invalid magic number!");

	/* Check bit 6 to see if we have a valid memory map */
	if (!(mbd->flags >> 6 & 0x1))
		kpanic("invalid memory map given by GRUB bootloader");

	/* Loop through the memory map and display the values */
	for (uint32_t i = 0; i < mbd->mmap_length;
	     i += sizeof(multiboot_memory_map_t)) {
		multiboot_memory_map_t *mmmt =
		    (multiboot_memory_map_t *)(mbd->mmap_addr + i);
		/* if (mmmt->type == MULTIBOOT_MEMORY_AVAILABLE) */
		/* mem_size += mmmt->len; */
	}
}

void kernel_main(multiboot_info_t *mbd, uint32_t magic)
{
	terminal_initialize();
	init_gdt();
	init_idt();
	init_memory(mbd, magic);
	load_drivers();
	kprintf(KERN_ALERT
	        "I see no way to confuse an array of 256 seg:off pairs with a "
	        "complex 8*unknown quantity -byte descriptor table. -- Troy "
	        "Martin 03:50, 22 March 2009 (UTC)\n");

	// PRINT_PTR(alloc_frame());
	if (false) {
		void *ptr;
		while ((ptr = alloc_pages(PAGE_SIZE * 1))) {
			if (ptr)
				memset(ptr, ~0, PAGE_SIZE * 1);
		}
	} else {
		while (vmalloc(10))
			;
	}
	/* vmalloc(10); */
	shell_init();
}
